<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.14" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="indexpage" kind="group">
    <compoundname>index</compoundname>
    <title>Core Library</title>
    <briefdescription>
    </briefdescription>
    <detaileddescription>
<para><heading level="2">Overview</heading>
</para><para>The Core Library provides basic types and utilities that can be used between different devices. This allows different libraries to share common items between themselves to avoid reimplementation and promote consistency.</para><para><heading level="2">Features</heading>
</para><para><itemizedlist>
<listitem><para>Common result type (<ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref>) for reporting errors or status</para></listitem><listitem><para>Common utility MACROs for<itemizedlist>
<listitem><para>CY_ASSERT: Verifies a value and halts if invalid (if not NDEBUG)</para></listitem><listitem><para>CY_HALT: Halts the application</para></listitem><listitem><para>CY_UNUSED_PARAMETER: Avoid warnings if a function argument isn't used</para></listitem><listitem><para>CY_LO8: Gets the lower 8 bits of a 16-bit value</para></listitem><listitem><para>CY_HI8: Gets the upper 8 bits of a 16-bit value</para></listitem><listitem><para>CY_LO16: Gets the lower 16 bits of a 32-bit value</para></listitem><listitem><para>CY_HI16: Gets the upper 16 bits of a 32-bit value</para></listitem><listitem><para>CY_SWAP_ENDIAN16: Swaps the byte ordering of a 16-bit value</para></listitem><listitem><para>CY_SWAP_ENDIAN32: Swaps the byte ordering of a 32-bit value</para></listitem><listitem><para>CY_SWAP_ENDIAN64: Swaps the byte ordering of a 64-bit value</para></listitem><listitem><para>CY_GET_REG8: Reads the 8-bit value from the specified address</para></listitem><listitem><para>CY_SET_REG8: Writes an 8-bit value to the specified address</para></listitem><listitem><para>CY_GET_REG16: Reads the 16-bit value from the specified address</para></listitem><listitem><para>CY_SET_REG16: Writes the 16-bit value to the specified address</para></listitem><listitem><para>CY_GET_REG24: Reads the 24-bit value from the specified address</para></listitem><listitem><para>CY_SET_REG24: Writes the 24-bit value to the specified address</para></listitem><listitem><para>CY_GET_REG32: Reads the 32-bit value from the specified register</para></listitem><listitem><para>CY_SET_REG32: Writes the 32-bit value to the specified register</para></listitem><listitem><para>_CLR_SET_FLD32U: The macro for setting a register with a name field and value for providing get-clear-modify-write operations</para></listitem><listitem><para>CY_REG32_CLR_SET: Uses _CLR_SET_FLD32U macro for providing get-clear-modify-write operations with a name field and value and writes a resulting value to the 32-bit register</para></listitem><listitem><para>_CLR_SET_FLD16U: The macro for setting a 16-bit register with a name field and value for providing get-clear-modify-write operations</para></listitem><listitem><para>CY_REG16_CLR_SET: Uses _CLR_SET_FLD16U macro for providing get-clear-modify-write operations with a name field and value and writes a resulting value to the 16-bit register</para></listitem><listitem><para>_CLR_SET_FLD8U: The macro for setting a 8-bit register with a name field and value for providing get-clear-modify-write operations</para></listitem><listitem><para>CY_REG8_CLR_SET: Uses _CLR_SET_FLD8U macro for providing get-clear-modify-write operations with a name field and value and writes a resulting value to the 8-bit register</para></listitem><listitem><para>_BOOL2FLD: Returns a field mask if the value is not false</para></listitem><listitem><para>_FLD2BOOL: Returns true, if the value includes the field mask</para></listitem><listitem><para>CY_SYSLIB_DIV_ROUND: Calculates a / b with rounding to the nearest integer, a and b must have the same sign.</para></listitem><listitem><para>CY_SYSLIB_DIV_ROUNDUP: Calculates a / b with rounding up if remainder != 0, both a and b must be positive.</para></listitem></itemizedlist>
</para></listitem><listitem><para>MACROs to create cross compiler compatible code. Use the CY_NOINIT, CY_SECTION, CY_UNUSED, CY_ALIGN attributes at the first place of declaration/definition. For example: CY_NOINIT uint32_t noinitVar;<itemizedlist>
<listitem><para>CY_NOINIT</para></listitem><listitem><para>CY_SECTION</para></listitem><listitem><para>CY_UNUSED</para></listitem><listitem><para>CY_NOINLINE</para></listitem><listitem><para>CY_ALIGN</para></listitem><listitem><para>CY_RAMFUNC_BEGIN</para></listitem><listitem><para>CY_RAMFUNC_END</para></listitem></itemizedlist>
</para></listitem></itemizedlist>
</para><para><heading level="2">More information</heading>
</para><para><itemizedlist>
<listitem><para><ulink url="https://cypresssemiconductorco.github.io/core-lib/html/modules.html">API Reference Guide</ulink></para></listitem><listitem><para><ulink url="http://www.cypress.com">Cypress Semiconductor, an Infineon Technologies Company</ulink></para></listitem><listitem><para><ulink url="https://github.com/cypresssemiconductorco">Cypress Semiconductor GitHub</ulink></para></listitem><listitem><para><ulink url="https://www.cypress.com/products/modustoolbox-software-environment">ModusToolbox</ulink> <hruler />
 © Cypress Semiconductor Corporation, 2019-2020. </para></listitem></itemizedlist>
</para>    </detaileddescription>
  </compounddef>
</doxygen>